#!/usr/local/bin/perl
#use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";
use CGI qw/:cgi/;
#use CGI::Carp qw(fatalsToBrowser);

require './config.cgi';

my $wide   = param('wide');
my $gm     = param('gm');
my $simple = param('simple');
my $reverse= param('rev');

my $division; my $formsize;

if($simple){
  $division = 'rows';
  $formsize = '75';
}
elsif($wide){
  $division = 'cols';
  $formsize = '440';
}
else{
  $division = 'rows';
  $formsize = '140';
}

print "Content-type: text/html\n\n";
print <<"HTML";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">
<html lang="ja">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <title>$set::title</title>
  </head>
HTML
if ($reverse) {
  print <<"HTML";
  <frameset $division="*, $formsize">
    <frame src="${set::chat}?mode=view@{[ ($reverse && !$wide) ? '&nb=1' : '' ]}" name="logs">
    <frame src="${set::chat}?mode=entrance@{[ $wide?'&wide=1':'' ]}@{[ $gm?'&gm=1':'' ]}@{[ $simple?'&simple=1':'' ]}" name="form">
HTML
} else {
  print <<"HTML";
  <frameset $division="$formsize, *">
    <frame src="${set::chat}?mode=entrance&@{[ $wide?'&wide=1':'' ]}@{[ $gm?'&gm=1':'' ]}@{[ $simple?'&simple=1':'' ]}" name="form">
    <frame src="${set::chat}?mode=view" name="logs">
HTML
}
print <<"HTML";
    <noframes>
    <body>
      フレーム非対応ブラウザでは利用できません。
    </body>
    </noframes>
  </frameset>
</html>
HTML
