var log_path = './log_pre.dat';
var num_path = './num.dat';
var mem_path = './mem_check.cgi';
var Counter = 0;
var MemCounter = 0;
var Lock = 0;
var LogCheckSet;
var LogCheckObj;
var MemCheckSet;
var MemCheckObj;
var TopicObj;
var TopicForm;
var TopicEdit = 0;
var CookieObj;
var StatusObj;
var FirstLoad = 0;


//ページがロードされた後に読み込まれます
function proc_onload() {
  log_check();
  timer_set();
}

function timer_set() {
  if (Name != "") {
    LogCheckSet = setInterval("log_check()",CheckTimeMem);
  } else {
    LogCheckSet = setInterval("log_check()",CheckTimeRom);
  }
}

function log_check() {
  if(Lock){
    clearInterval(LogCheckSet);
    timer_set();
    return;
  } else {
    Lock = 1;
    LogCheckObj = createXMLHttpRequest();
    LogCheckObj.onreadystatechange = log_check_get;
    LogCheckObj.open("GET",num_path+'?'+(new Date()).getTime(),true);
    LogCheckObj.send(null);
    
    if(MemCounter >= 100){ mem_check(0); MemCounter = 0; }
    
    if (Name != "") {
      MemCounter += MemTimeMem;
    } else {
      MemCounter += MemTimeRom;
    }
  }
}
function log_check_get() {
  if(LogCheckObj.readyState == 4 && LogCheckObj.status == 200){
    if(LogCheckObj.responseText != Counter){
      data_load(Counter);
      Counter = LogCheckObj.responseText;
      mem_check(1);
    }
  } else {
    Lock = 0;
  }
}

function data_load(x) {
  DataLoadObj = createXMLHttpRequest();
  DataLoadObj.onreadystatechange = function() { data_get(x); };
  DataLoadObj.open('GET',log_path+"?"+(new Date()).getTime(),true);
  DataLoadObj.send(null);
}
function data_get(Now) {
  if (DataLoadObj.readyState == 4 && DataLoadObj.status == 200){
    var Logs = self.document.getElementById("log");
    var str = DataLoadObj.responseText;
    if(Now > Counter){ Now = 0; }
    if(str){
      var nums = new Array();
      var text = new Array();
      var line = str.split("\n");
      for(i = 0 ; i < line.length; i++){
        if(!line[i]){ continue; }
        var LogHtml = '';
        var data = line[i].split("<>");
        LogHtml += ' <dd class="date">'+data[1]+'</dd>';
        LogHtml += '<dt';
        LogHtml += (data[7] == "*") ? ' class="system"' : '';
        LogHtml += ' style="color:'+data[6]+'">'+data[2]+'</dt>';
        LogHtml += '<dd class="comm">';
        LogHtml += (data[3] || data[4]) ? data[3] : '&nbsp;';
        if(data[4] != "") {
          LogHtml += ' <span class="supp">'+data[4]+'</span>'
        }
        LogHtml += '</dd>';
        if(data[5] != "") {
          LogHtml += '<dd class="dice">'+data[5]+'</dd>';
        }
        if(self.document.getElementById(data[0])){
          continue;
        }
        nums.unshift(data[0]);
        text.unshift(LogHtml);
      }
      for(i = 0 ; i < nums.length; i++){
        if(self.document.getElementById(nums[i])){
          var delNode = document.getElementById(nums[i]);
          delNode.parentNode.removeChild(delNode);
        }
        var cH; var remain;
        if(NewBottom) {
        var sT = document.body.scrollTop || document.documentElement.scrollTop;
        var sH = document.documentElement.scrollHeight || document.body.scrollHeight;
            cH = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
            remain = sH - sT - cH;
        }
        var newLog = document.createElement('dl'); 
        newLog.id = nums[i];
        newLog.setAttribute('class', 'line');
        newLog.setAttribute('className', 'line');
        newLog.style.opacity = 0;
        newLog.innerHTML = text[i];
        if(NewBottom) {
          Logs.appendChild(newLog);
          if(remain == 0){ window.scrollBy(0, cH); }
        }
        else {
          Logs.insertBefore(newLog, Logs.firstChild);
        }
        setTimeout("fadein("+nums[i]+")", 50);
      }
      var childs = document.getElementById('log').childNodes;
      for(i = childs.length; i > 200; i--){
        if(NewBottom) { Logs.removeChild(Logs.firstChild); }
        else          { Logs.removeChild(Logs.lastChild); }
      }
    } else {
      self.document.getElementById("log").innerHTML = "";
    }
  }
  Lock = 0;
  if(NewBottom && FirstLoad){ FirstLoad = 1; setTimeout("firstload()", 100) }
}

function fadein(num,remain){
  document.getElementById(num).style.opacity = 1;
}

function firstload(){
  var cH = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
      cH += 1000;
  window.scrollBy(0, cH);
}

function mem_check(readonly) {
  var SendName = (EncoName ? '&name='+EncoName : '');
  var Stt_on = 0;
  var Hp = '';
  var Mp = '';
  var Gp = '';
  var Pp = '';
  var Game = '';
  var Rom = (readonly ? '&ro=1' : '');
  if(Name != ""){
    if (parent.form.document.send.stt_on.checked) {
      Stt_on = 1;
      Hp = parent.form.document.send.hp.value;
      Mp = parent.form.document.send.mp.value;
      Gp = parent.form.document.send.gp.value;
      Pp = parent.form.document.send.pp.value;
      Hp = '&hp='+encodeURIComponent(Hp);
      Mp = '&mp='+encodeURIComponent(Mp);
      Gp = '&gp='+encodeURIComponent(Gp);
      Pp = '&pp='+encodeURIComponent(Pp);
    }
    Game = '&game='+parent.form.document.send.game.value;
  }
  MemCheckObj = createXMLHttpRequest();
  MemCheckObj.onreadystatechange = mem_check_get;
  MemCheckObj.open("GET",mem_path+'?'+(new Date()).getTime()+SendName+Game+'&stt_on='+Stt_on+Hp+Mp+Gp+Pp+Rom,true);
  MemCheckObj.send();
}
function mem_check_get() {
  if(MemCheckObj.readyState == 4 && MemCheckObj.status == 200){
    var str = MemCheckObj.responseText;
    var data = str.split("<>");
    self.document.getElementById("topic").innerHTML = data[0];
    self.document.getElementById("topic_h").innerHTML = data[0];
    self.document.getElementById("status").innerHTML = data[4];
    self.document.getElementById("rom_num").innerHTML = data[3];
  }
}

function font_size_change(Select) {
  self.document.body.style.fontSize = Select.options[Select.selectedIndex].value;
  cookie_font();
}
function font_family_change(Select) {
  if(Select.options[Select.selectedIndex].value){
    self.document.body.style.fontFamily = Select.options[Select.selectedIndex].value;
  } else {
    self.document.body.style.fontFamily = '"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro","メイリオ","Meiryo","ＭＳ Ｐゴシック","MS PGothic",sans-serif';
  }
  cookie_font();
}
function cookie_font() {
  var Size = self.document.getElementById("font_size").options[self.document.getElementById("font_size").selectedIndex].value;
  var Fami = self.document.getElementById("font_family").options[self.document.getElementById("font_family").selectedIndex].value;
  var Exp = new Date();
      Exp.setTime(Exp.getTime()+1000*60*60*24*365);
  document.cookie = 'ytchat2font=' +  escape(Size) + '<>' +  escape(Fami) + '; expires=' + Exp.toGMTString() + ';';
}

function topic_submit() {
  var TopicCheck = self.document.getElementById("topic_check").value;
  if(TopicCheck == 1){
    TopicValue = self.document.getElementById("topic").value;
    var TopicValueEnc = encodeURIComponent(TopicValue);
    TopicObj = createXMLHttpRequest();
    TopicObj.open('POST',chat_path,true);
    TopicObj.send('&mode=topic&name='+EncoName+'&topic='+TopicValueEnc);
    TopicValue = TopicValue.replace(/</g,"&lt;");
    TopicValue = TopicValue.replace(/>/g,"&gt;");
    topic_on();
    self.document.getElementById("topic_h").innerHTML = TopicValue;
    log_check();
  }
}

function topic_on() {
  if(TopicEdit == 1){
    TopicEdit = 0;
    self.document.getElementById("topic_td").innerHTML = '<div id="topic">'+TopicValue+'</div><input type="hidden" id="topic_check" value="0">';
    self.document.getElementById("topic_e").innerHTML = '&#x270E;';
    self.document.getElementById("log").style.marginTop = 3 + 'px';
  }
  else {
    TopicEdit = 1;
    TopicValue = self.document.getElementById("topic").innerHTML;
    TopicValue = TopicValue.replace(/"/g,"&quot;");
    self.document.getElementById("topic_td").innerHTML = '<input type="text" id="topic" value="'+TopicValue+'"><span class="button" id="topic_s" onClick="topic_submit()">書込</span><input type="hidden" id="topic_check" value="1">';
    self.document.getElementById("topic_e").innerHTML = '×';
    self.document.getElementById("log").style.marginTop = 20 + 'px';
  }
}

function status_submit() {
try {
  var Stt_on;
  if(parent.form.document.send.stt_on.checked){
    Stt_on = 1;
  } else {
    Stt_on = 0;
  }
  var Hp = parent.form.document.send.hp.value;
  var Mp = parent.form.document.send.mp.value;
  var Gp = parent.form.document.send.gp.value;
  var Pp = parent.form.document.send.pp.value;
  StatusObj = createXMLHttpRequest();
  StatusObj.open('POST',chat_path,true);
  StatusObj.send('&mode=regist&name='+EncoName+'&stt_on='+Stt_on+'&hp='+Hp+'&mp='+Mp+'&gp='+Gp+'&pp='+Pp);
  alert("ステータスを更新しました。");
} catch(e) {
  alert("ステータスを更新に失敗しました。");
}
}

function cookie_submit() {
try {
  var NameEnc = EncoName;
  var Color = parent.form.document.send.color.value;
      Color = encodeURIComponent(Color);
  var Game  = parent.form.document.send.game.value;
  var Upper = parent.form.Upper;
  var Result= '';
  
  if(self.document.getElementById("cc_name").checked) { Result += '名前　';     } else { NameEnc = ''; }
  if(self.document.getElementById("cc_color").checked){ Result += '名前色　';   } else { Color = ''; }
  if(self.document.getElementById("cc_mode").checked) { Result += '入室モード'; } else { Game = ''; Upper = ''; }
  
  CookieObj = createXMLHttpRequest();
  CookieObj.open('POST',chat_path,true);
  CookieObj.send('&mode=regist&act=cookie&name='+NameEnc+'&color='+Color+'&game='+Game+'&upper='+Upper);
  alert("【Cookieを保存しました】\n保存項目："+Result);
} catch(e) {
  alert("Cookieの保存に失敗しました。");
}
}

function createXMLHttpRequest() {
  var XMLhttpObject = null;
  try {
    XMLhttpObject = new XMLHttpRequest();
  }
  catch(e) {
    try{
      XMLhttpObject = new ActiveXObject("Msxml2.XMLHTTP");
    }
    catch(e) {
      try {
        XMLhttpObject = new ActiveXObject("Microsoft.XMLHTTP");
      }
      catch(e) {
        return null;
      }
    }
  }
  return XMLhttpObject;
}

window.onload=proc_onload;