#use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";

package gehenna;

sub gedc {
  my $out_dice;

  my $quant = $::in{'geq'.($_[0])};
  my $crit  = $::in{'geb'.($_[0])};
  my $check = $::in{'ger'.($_[0])};
  my $add   = $::in{'gea'.($check)};
  
  if($quant ne ''){ $quant =~ s/^\+//; $quant =~ s/[^0-9\.\+\-\*\/\(\)]//g; $quant =~ tr/\.\+\-\*\///s; } else { $quant = 1; }
  if($crit ne '') { $crit  =~ s/^\+//; $crit  =~ s/[^0-9\.\+\-\*\/\(\)]//g; $crit  =~ tr/\.\+\-\*\///s; } else { $crit  = 6; }
  if($add ne '')  { $add   =~ s/^\+//; $add   =~ s/[^0-9\.\+\-\*\/\(\)]//g; $add   =~ tr/\.\+\-\*\///s; } else { $add   = 0; }
  
  my $ev_quant= eval($quant);
  my $ev_crit = eval($crit);
  my $ev_add  = eval($add);
  
  if($ev_quant > 200) { return $out_dice.$quant.'g'.$crit.'→ ダイスは200個以下に収めてください' }
  
  $out_dice .= $quant.'g'.$crit.' → <small>';
  my @numbers;
  my $good = 0;
  my $fail = 0;
  $out_dice .= '[';
  for (my $i = 0; $i < $ev_quant; $i++) {
    my $number = int(rand(6)) + 1;
    push(@numbers, $number);
    if($number >= $ev_crit){ $good++; } else { $fail++; }
  }
  $out_dice .= join(', ',@numbers).']';
  
  if($add){ return '<span style="color:'.$set::color_gedc_form.'">'.$out_dice.' : ○<b>'.$good.'</b>／×<b>'.$fail.'</b> + 【<b>'.$add.'</b>】</small> = </span><b style="color:'.$set::color_gedc.';">'.($good + $ev_add).'</b>'; }
  else    { return '<span style="color:'.$set::color_gedc_form.'">'.$out_dice.' : ○<b>'.$good.'</b>／×<b>'.$fail.'</b></small> = </span><b style="color:'.$set::color_gedc.';">'.$good.'</b>'; }
}

1;