#!/usr/local/bin/perl
#use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";

require './config.cgi';
require './pl/colors.pl';

print "Content-type: text/html\n\n";
print <<"HTML";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <title>$set::title</title>
  <style TYPE="text/css">
  body { padding:15px; line-height:1; font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro","メイリオ","meiryo","ＭＳ Ｐゴシック","MS PGothic","Osaka",sans-serif; color:$set::color_font; background-color:$set::color_back; }
  tt { font-family:monospace; }
  table{ border:1px solid $set::color_font; border-collapse:collapse; }
  th,td{ border-bottom:1px solid $set::color_font; padding:3px; font-size:14px; }
  </style>
<head>
<body>
  <table style="margin:5px auto;">
HTML
  for(@::colors) {
    print "\t\t<tr><th style=\"color:@$_[0];\">@$_[1]</th><td style=\"color:@$_[0];padding:3px 10px;\"><tt>@$_[0]</tt></td><td style=\"background-color:@$_[0];width:50px;\">&nbsp;</td></tr>\n";
  }
print <<'HTML';
  </table>
</body>
</html>
HTML
