#!/usr/local/bin/perl
#use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";

use Encode;

require './config.cgi';

my %in;
my %out;

my $buf;

my @mem_stt;

if ($ENV{'REQUEST_METHOD'} eq "POST") {
  read(STDIN, $buf, $ENV{'CONTENT_LENGTH'});
}
else { $buf = $ENV{'QUERY_STRING'}; }
my @pairs = split(/&/, $buf);
foreach (@pairs) {
  my ($name,$value) = split(/=/, $_);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $in{$name} = Encode::decode('utf8', $value);
}
## ホスト(IP)取得
$out{'host'} = $ENV{'REMOTE_HOST'};
if(!$out{'host'}){ $out{'host'} = $ENV{'REMOTE_ADDR'}; }
$out{'host_c'} = &host_cut($out{'host'});


my $time = time;
my $over;
my $newadd;
foreach('name','hp','mp','gp','pp') {
  $in{$_} =~ s/</&lt;/g;
  $in{$_} =~ s/>/&gt;/g;
  $in{$_} =~ s/\r//g;
  $in{$_} =~ s/\n//g;
  $in{$_} =~ s/\\/&#92;/g;
  $in{$_} =~ s/"/&quot;/g;
}
if(!$in{'stt_on'}) { $in{'hp'} = $in{'mp'} = $in{'gp'} = $in{'pp'} = ''; }


$out{'mem_num'} = $out{'rom_num'} = 0;
my $stt_on = 0;
if(!$in{'ro'}){
  open(my $FH, "+<:utf8", './mem_list.dat') or &error('./mem_list.datが開けません');
  flock($FH, 2);
  my $i = 0;
  while(my $line = <$FH>) {
    if(!$i) {
      $i++;
      chomp($line);
      $out{'topic'} = $line;
      next;
    }
    my($date,$name,$host,$hp,$mp,$gp,$pp) = split(/<>/, $line);
    my $host_c = &host_cut($host);
    if($time-300 > $date) { next; }
    if($name eq $in{'name'} && $host_c eq $out{'host_c'}) {
      $newadd = 1;
      $hp = $in{'hp'}; $mp = $in{'mp'}; $gp = $in{'gp'}; $pp = $in{'pp'};
      $line = "$time<>$name<>$host<>$hp<>$mp<>$gp<>$pp<>\n";
    }
    $over .= $line;
    if($name){
      my $sort = 0;
      $out{'members'} .= "$name◆";
      $out{'mem_num'}++;
      if($hp ne '' || $mp ne '' || $gp ne '' || $pp ne ''){
        $stt_on = 1;
        if   ($in{'game'} eq 'dx3'){ $sort = eval($mp); }
        elsif($in{'game'} eq 's-f'){ $sort = eval($gp); }
        push (@mem_stt, "$sort<>$name<>$hp<>$mp<>$gp<>$pp<>");
      }
      else { push (@mem_stt, "$sort<>$name<><><><><>"); }
    }
    else { $out{'rom_num'}++; }
  }
  if(!$newadd){
    $over .= "$time<>$in{'name'}<>$out{'host'}<>$in{'hp'}<>$in{'mp'}<>$in{'gp'}<>$in{'pp'}<>\n";
    if($in{'name'}){
      my $sort = 0;
      $out{'members'} .= "$in{'name'}◆";
      $out{'mem_num'}++;
      if($in{'hp'} ne '' || $in{'mp'} ne '' || $in{'gp'} ne '' || $in{'pp'} ne '') {
        $stt_on = 1;
        if   ($in{'game'} eq 'dx3'){ $sort = eval($in{'mp'}); }
        elsif($in{'game'} eq 's-f'){ $sort = eval($in{'gp'}); }
        push (@mem_stt, "$sort<>$in{'name'}<>$in{'hp'}<>$in{'mp'}<>$in{'gp'}<>$in{'pp'}<>");
      }
      else { push (@mem_stt, "$sort<>$in{'name'}<><><><><>"); }
    }
    else { $out{'rom_num'}++; }
  }
  seek($FH, 0, 0);
  print $FH $out{'topic'},"\n",$over;
  truncate($FH, tell($FH));
  close($FH);
}
else {
  open(my $FH, "<:utf8", './mem_list.dat') or &error('./mem_list.datが開けません');
  my $i = 0;
  while(my $line = <$FH>) {
    if(!$i) {
      $i++;
      chomp($line);
      $out{'topic'} = $line;
      next;
    }
    my($date,$name,$host,$hp,$mp,$gp,$pp) = split(/<>/, $line);
    if($time-300 > $date) { next; }
    if($name){
      my $sort;
      $out{'members'} .= "$name◆";
      $out{'mem_num'}++;
      if($hp ne '' || $mp ne '' || $gp ne '' || $pp ne ''){
        $stt_on = 1;
        if   ($in{'game'} eq 'dx3'){ $sort = eval($mp); }
        elsif($in{'game'} eq 's-f'){ $sort = eval($gp); }
        push (@mem_stt, "$sort<>$name<>$hp<>$mp<>$gp<>$pp<>");
      }
      else { push (@mem_stt, "$sort<>$name<><><><><>"); }
    }
    else { $out{'rom_num'}++; }
  }
  close($FH);
}
@mem_stt = sort { (split(/<>/,$b))[0] <=> (split(/<>/,$a))[0] } @mem_stt;
if ($out{'mem_num'}){
  $out{'mem_stt'} = '<table class="status"><tr><th>参加者('.$out{'mem_num'}.')</th>';
  if($stt_on){
    if   ($in{'game'} eq 'sw2'){ $out{'mem_stt'} .= '<th>HP</th><th>MP</th><th>防</th><th></th></tr>'; }
    elsif($in{'game'} eq 'dx3'){ $out{'mem_stt'} .= '<th>HP</th><th>行動</th><th>侵蝕</th><th></th></tr>'; }
    elsif($in{'game'} eq 's-f'){ $out{'mem_stt'} .= '<th>HP</th><th>MP</th><th>ﾌﾟﾗｰﾅ</th><th>行動</th></tr>'; }
    else { $out{'mem_stt'} .= '<th>HP</th><th>MP</th><th>他</th><th></th></tr>'; }
    for(@mem_stt){
      my($sort,$name,$hp,$mp,$gp,$pp) = split(/<>/, $_);
      $out{'mem_stt'} .= "<tr><th><b>$name</b></th><td>$hp</td><td>$mp</td><td>$gp</td><td>$pp</td></tr>";
    }
  } else {
    for(@mem_stt){
      my($sort,$name,undef,undef,undef) = split(/<>/, $_);
      $out{'mem_stt'} .= "<tr><th><b>$name</b></th></tr>";
    }
  }
  $out{'mem_stt'} .= '</table>';
}

print "Content-type: text/plain; charset=UTF-8\n\n";
print "$out{'topic'}<>$out{'members'}<>$out{'mem_num'}<>$out{'rom_num'}<>$out{'mem_stt'}";

sub host_cut {
  my $host_in = shift; my $host_out;
  if   ($host_in =~ /(.*)\.(\d+?)$/)          { $host_out = "$1\.*"; }
  elsif($host_in =~ /(.*)\.(.*)\.(.*)\.(.*)$/){ $host_out = "\*\.$2\.$3\.$4"; }
  elsif($host_in =~ /(.*)\.(.*)\.(.*)$/)      { $host_out = "\*\.$2\.$3"; }
  return $host_out;
}