#use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";

package dx3;

sub dxdc {
  my $out_dice;

  my @color = split(/,/, $set::color_dxdc_crit);

  my $quant = $::in{'dxq'.($_[0])};
  my $crit  = $::in{'dxc'.($_[0])};
  my $check = $::in{'dxr'.($_[0])};
  my $add   = $::in{'dxa'.($check)};
  my $total;
  
  if($quant ne ''){ $quant =~ s/^\+//; $quant =~ s/[^0-9\.\+\-\*\/\(\)]//g; $quant =~ tr/\.\+\-\*\///s; } else { $quant = 1; }
  if($crit ne '') { $crit  =~ s/^\+//; $crit  =~ s/[^0-9\.\+\-\*\/\(\)]//g; $crit  =~ tr/\.\+\-\*\///s; } else { $crit  = 10; }
  if($add ne '')  { $add   =~ s/^\+//; $add   =~ s/[^0-9\.\+\-\*\/\(\)]//g; $add   =~ tr/\.\+\-\*\///s; } else { $add   = 0; }
  
  my $ev_quant= eval($quant);
  my $ev_crit = eval($crit);
  my $ev_add  = eval($add);
  
  if($ev_quant > 200) { return $out_dice.$quant.'R'.$crit.'→ 判定値は200以下に収めてください' }
  
  $out_dice .= $quant.'R'.$crit.' → <small>';
  my $c;
  for($c = 0; $ev_quant > 0; $c++){
    my $max = 0;
    my $next = 0;
    my @numbers;
    $out_dice .= '[';
    for (my $i = 0; $i < $ev_quant; $i++) {
      my $number = int(rand(10)) + 1;
      push(@numbers, $number);
      if($number > $max) { $max = $number; }
      if($number >= $ev_crit){ $max = 10; $next++; }
    }
    $total += $max;
    $ev_quant = $next;
    # @numbers = sort { $a <=> $b } @numbers;
    $out_dice .= join(', ',@numbers).']';
    
    if($#color < $c){ $c = $#color; }
    
    if($next && $ev_crit > 1){ $out_dice = '<span style="color:'.$color[$c].'">'.$out_dice.(($set::critical_text)?"<b>$set::critical_text</b>":'').' </span>'; }
    elsif(!$c && $total == 1){
      return '<span style="color:'.$set::color_dxdc_fumb.'">'.$out_dice.(($set::fumble_text)?"<b>$set::fumble_text</b>":'').' : </small> = </span><b style="color:'.$set::color_dxdc.';">0</b>';
    }
    elsif($ev_crit < 2){ return $out_dice.'</small> ... = <b style="color:'.$set::color_dxdc.';">∞</b>'; }
    else {
      if($add){ return '<span style="color:'.$color[$c].'">'.$out_dice.' : <b>'.$total.'</b> + 【<b>'.$add.'</b>】</small> = </span><b style="color:'.$set::color_dxdc.';">'.($total + $ev_add).'</b>'; }
      else { return '<span style="color:'.$color[$c].'">'.$out_dice.' : <b>'.$total.'</b></small> = </span><b style="color:'.$set::color_dxdc.';">'.$total.'</b>'; }
    }
  }
}

1;