#use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";

package s_f;

sub sfdc {
  my $out_dice;

  my @color = split(/,/, $set::color_sfdc_crit);

  my $crit  = $::in{'sfc'.($_[0])};
  my $fumb  = $::in{'sff'.($_[0])};
  my $check = $::in{'sfr'.($_[0])};
  my $add   = $::in{'sfa'.($check)};
  my $total;
  my $compute;
  
  if($crit ne '') { $crit  =~ s/^\+//; $crit =~ s/[@＠，、]/,/g; $crit =~ s/[^0-9,]//g; $crit =~ s/^,//g; } else { $crit  = 0; }
  if($fumb ne '') { $fumb  =~ s/^\+//; $fumb =~ s/[#＃，、]/,/g; $fumb =~ s/[^0-9,]//g; $fumb =~ s/^,//g; } else { $fumb  = 0; }
  if($add ne '')  { $add   =~ s/^\+//; $add   =~ s/[^0-9\.\+\-\*\/\(\)]//g; $add   =~ tr/\.\+\-\*\///s; } else { $add   = 0; }
  
  my @crits = split(/,/, $crit);
  my @fumbs = split(/,/, $fumb);
  my $ev_add  = eval($add);
  $total = $ev_add;
  
  my %cc;
  foreach my $crit (@crits){
    $cc{$crit} = 1;
  }
  
  if($cc{'2'} && $cc{'3'} && $cc{'4'} && $cc{'5'} && $cc{'6'} && $cc{'7'} && $cc{'8'} && $cc{'9'} && $cc{'10'} && $cc{'11'} && $cc{'12'}) {
    return '<span style="'.$set::color_sfdc.'">SF'.($crit ? ' <small>C:'.$crit.'</small>' : '').($fumb ? ' <small>F:'.$fumb.'</small>' : '')
      .' → <b>∞</b></span>';
  }
  $out_dice .= 'SF'.($crit ? ' <small>C:'.$crit.'</small>' : '').($fumb ? ' <small>F:'.$fumb.'</small>' : '').' → <small>';
  
  
  my $c;
  for (my $i = 0; $i < 1000; $i++) {
    my $number; my $amount; my $formula; my $result;
    my $fc; my $ff;
    
    my $dice1 = int(rand(6)) + 1;
    my $dice2 = int(rand(6)) + 1;
    $formula  = "$dice1 + $dice2";
    $number = $dice1 + $dice2;
    
    foreach my $crit (@crits){
      if($number == $crit){ $fc = 1; $c++; last; }
    }
    if(!$c){
      foreach my $fumb (@fumbs){
        if($number == $fumb){ $ff = 1; last; }
      }
    }
    $out_dice .= '(' . $formula . ' = ' . $number . ($fc ? " &gt; 10 <b>${set::critical_text}</b>" : $ff ? " <b>${set::fumble_text}</b>" : '') . ')' . ($fc ? ' + ' : ' ');
    $total += $fc ? 10 : $ff ? -10 : $number;
    
    if($fc){ next; }
    
    if($add){ $out_dice .= '+ 【<b>'.$add.'</b>】</small> = <b style="color:'.$set::color_sfdc.';">'.$total.'</b>'; }
    else    { $out_dice .= '</small>= <b style="color:'.$set::color_sfdc.';">'.$total.'</b>'; }
    $out_dice = '<span style="color:'.($ff ? $set::color_sfdc_fumb : $color[$i]).'">'.$out_dice.'</span>';
    
    last;
  }
  return $out_dice;
}

1;